<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
</head>

<body>
  <h1>JavaScript homework: 01</h1>
  <hr>

  <h2>Обьяснить своими словами разницу между обьявлением переменных через var, let и const.</h2>
  <p>
    <code>var</code> - появился первым и был единственным до специфицакии es5.
    <br>
    <code>let</code> - появился в специфицакии es6. Он похож на <code>var</code> но в отличии от
    var движок JavaScript не поднимает объявление переменных которые объявлены с помощью <code>let</code>, а создает
    переменную
    с <code>let</code> только тогда когда обработчик JavaScript до нее доходит. <code>let</code> имеет только блочную
    область видимости.
    <br>
    <code>const</code> - появился в специфицакии es6. Предназначен для объявление констант или сталых значений которые
    нельзя перезаписывать.
  </p>

  <h2>Почему объявлять переменную через var считается плохим тоном?</h2>
  <p>
    <br>
    Движок JavaScript понимает <code>var a = 2</code> как
    <code>var a;</code> <code>a = 2;</code> как два отдельных оператора: оператор объявления переменной и оператор
    присвоения значения. Это приводит к такому понятию как всплытие переменных (hoisting) - объявления переменных
    поднимаются наверх области видимости, а присвоение нет.
    <br>
    <br>
    <code>
      console.log(a); // undefined <br>
      var a = 2; <br>
      console.log(a) // 2 <br>
    </code>
  </p>
  <script src="./js/index.js"></script>
</body>

</html>